package net.sf.sql2java.data.holders;

import net.sf.sql2java.common.beans.datatype.SqlDataType;
import net.sf.sql2java.data.node.BasicNodelet;


public class Column extends BasicNodelet {
	private static final long serialVersionUID = 6444605767178148456L;

	private String defaultValue;
	private String remarks;
	
	private SqlDataType dataType;
	private int size;
	private int decimalDigits;
	private int numbersPrecedingRadix;
	private int nullable;
	private int ordinalPosition;
	
	private short keySequence;
	
	private boolean readable;
	private boolean writable;
	
// -- Constructors ------------------------------------------------------------
	
	public Column(String name) {
		super("column", name);
	}
	
// -- Getters -----------------------------------------------------------------
	
	public String getDefaultValue() {
		return defaultValue;
	}
	
	public String getRemarks() {
		return remarks;
	}
	
	public SqlDataType getDataType() {
		return dataType;
	}
	
	public int getSize() {
		return size;
	}
	
	public int getDecimalDigits() {
		return decimalDigits;
	}
	
	public int getNumbersPrecedingRadix() {
		return numbersPrecedingRadix;
	}
	
	public int getNullable() {
		return nullable;
	}
	
	public int getOrdinalPosition() {
		return ordinalPosition;
	}
	
	public boolean isReadable() {
		return readable;
	}
	
	public boolean isWritable() {
		return writable;
	}
	
	public boolean isPrimaryKey() {
		return keySequence != -1;
	}
	
	public short getKeySequence() {
		return keySequence;
	}
	
	public String getFullName() {
		StringBuffer result = new StringBuffer();
		
		if (getTable() != null)
			result.append(getTable().getName()).append(".");
		
		result.append(getName());
			
		return result.toString();
	}
	
	public Table getTable() {
		if (getParent() == null) return null;
		else return (Table) getParent();
	}
	
// -- Setters -----------------------------------------------------------------
	
	public void setDefaultValue(String defaultValue) {
		this.defaultValue = defaultValue;
	}
	
	public void setRemarks(String remarks) {
		this.remarks = remarks;
	}
	
	public void setDataType(SqlDataType dataType) {
		this.dataType = dataType;
	}
	
	public void setSize(int size) {
		this.size = size;
	}
	
	public void setDecimalDigits(int decimalDigits) {
		this.decimalDigits = decimalDigits;
	}
	
	public void setNumbersPrecedingRadix(int numbersPrecedingRadix) {
		this.numbersPrecedingRadix = numbersPrecedingRadix;
	}
	
	public void setNullable(int nullable) {
		this.nullable = nullable;
	}
	
	public void setOrdinalPosition(int ordinalPosition) {
		this.ordinalPosition = ordinalPosition;
	}
	
	public void setReadable(boolean readable) {
		this.readable = readable;
	}

	public void setWritable(boolean writable) {
		this.writable = writable;
	}
	
	public void setKeySequence(short keySequence) {
		this.keySequence = keySequence;
	}
}
