package net.sf.sql2java.data.holders;

import java.util.List;

import net.sf.sql2java.data.MapPointer;
import net.sf.sql2java.data.Path;
import net.sf.sql2java.data.node.BasicNodelet;

@SuppressWarnings("unchecked")
public class Database extends BasicNodelet {
	private static final long serialVersionUID = -8747547147209697443L;

	private String driver;
	private String url;
	private String username;
	private String password;
	
// -- Constructors ------------------------------------------------------------
	
	public Database(String catalog) { 
		super("database", catalog);
	}
	
// -- Tables ------------------------------------------------------------------
	
	public Schema createSchema(String name) {
		// -- create the result
		Schema schema = new Schema(name);
		
		// -- save the schema
		saveSchema(schema);
		
		// -- return the result
		return schema;
	}
	
	public void saveSchema(Schema schema) {
		put(schema);
	}
	
	public void removeSchema(String schemaName) {
		String strPath = String.format(MapPointer.FORMAT, "schema", schemaName);
		
		remove(Path.createPath(strPath));
	}
	
	public Table getSchema(String schemaName) {
		String strPath = String.format(MapPointer.FORMAT, "schema", schemaName);
		
		return (Table) get(Path.createPath(strPath));
	}

// -- Getters -----------------------------------------------------------------
	
	public String getDriver() {
		return driver;
	}

	public String getUrl() {
		return url;
	}

	public String getUsername() {
		return username;
	}

	public String getPassword() {
		return password;
	}

	public List<Table> getSchemas() {
		return list(Path.createPath("schema"));
	}

// -- Setters -----------------------------------------------------------------
	
	public void setDriver(String driver) {
		this.driver = driver;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public void setPassword(String password) {
		this.password = password;
	}
}
