package net.sf.sql2java.data.holders;

import java.util.List;

import net.sf.sql2java.data.MapPointer;
import net.sf.sql2java.data.Path;
import net.sf.sql2java.data.node.BasicNodelet;

public class Schema extends BasicNodelet {
	private static final long serialVersionUID = 1618696571370575326L;

// -- Constructors ------------------------------------------------------------
	
	public Schema(String name) {
		super("schema", name);
	}

// -- Tables ------------------------------------------------------------------
	
	public Table createTable(String name) {
		// -- create the result
		Table result = new Table(name);
		
		// -- save the result
		saveTable(result);
		
		// -- return the result
		return result;
	}
	
	public void saveTable(Table table) {
		put(table);
	}
	
	public void removeTable(String tableName) {
		String strPath = String.format(MapPointer.FORMAT, "table", tableName);
		
		remove(Path.createPath(strPath));
	}
	
	public Table getTable(String tableName) {
		String strPath = String.format(MapPointer.FORMAT, "table", tableName);
		
		return get(Path.createPath(strPath));
	}
	
// -- Getters -----------------------------------------------------------------
	
	public List<Table> getTables() {
		return list(Path.createPath("table"));
	}
	
	public Database getDatabase() {
		if (getParent() == null) return null;
		else return (Database) getParent();
	}
}
