/*
 * Template.java
 *
 * Created on 23 februari 2007, 9:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.sf.sql2java.generator.template;

import net.sf.sql2java.packages.TemplatePack;

/**
 *
 * @author daang
 */
public class Template {
    private String name;
    private String resource;
    private String scope;
    private TemplatePack templatePack;
    private String content;
    
    private String pkg;
    private String filename;
    private String extension;
    
// -- Constructors ------------------------------------------------------------
    
    public Template() {
        this("", "", "unknown");
    }
    
    public Template(String name, String resource, String scope) {
        this.name = name;
        this.resource = resource;
        this.scope = scope;
    }
    
// -- Getters -----------------------------------------------------------------
    
    public String getName() {
        return name;
    }

    public String getResource() {
        return resource;
    }

    public String getScope() {
        return scope;
    }
    
    public String getContent() {
        return content;
    }
    
    public TemplatePack getTemplatePack() {
        return templatePack;
    }
    
    public String getPackage() {
        return pkg;
    }
    
    public String getFilename() {
        return filename;
    }
    
    public String getExtension() {
        return extension;
    }
    
    public String getFullFilename() {
        return filename + extension;
    }
    
    public String getFullyQualifiedName() {
    	return getPackage() + "." + getFilename();
    }
    
// -- Setters -----------------------------------------------------------------

    public void setName(String name) {
        this.name = name;
    }
    
    public void setResource(String resource) {
        this.resource = resource;
    }

    public void setScope(String scope) {
        this.scope = scope;
    }

    public void setContent(String content) {
        this.content = content;
    }
    
    public void setTemplatePack(TemplatePack templatePack) {
        this.templatePack = templatePack;
    }
    
    public void setPkg(String pkg) {
        this.pkg = pkg;
    }

    public void setFilename(String filename) {
        this.filename = filename;
    }

    public void setExtension(String extension) {
        this.extension = extension;
    }
}
