/*
 * Merger.java
 *
 * Created on 9 mei 2007, 8:26
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.sf.sql2java.generator.writer;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.Reader;
import java.util.HashMap;
import java.util.Map;
import net.sf.sql2java.common.parameters.ParameterizedString;

/**
 *
 * @author daang
 */
public class UsercodeMerger {
    public static final String USERCODE_START_PATTERN   = "<usercode>";
    public static final String USERCODE_END_PATTERN     = "</usercode>";
    
    public static final String USERIMPORT_START_PATTERN = "<userimport>";
    public static final String USERIMPORT_END_PATTERN   = "</userimport>";
    
// -- Constructors ------------------------------------------------------------
    
    public UsercodeMerger() { 
    }

// -- Implementations ---------------------------------------------------------
    
    public Map<String, StringBuffer> fetchUsercode(BufferedReader brOriginal) throws IOException {
        // -- create the result object
        Map<String, StringBuffer> result = new HashMap<String, StringBuffer>();
        
        // -- Initialize the hashmap
        result.put("usercode", new StringBuffer());
        result.put("userimport", new StringBuffer());
        
        // -- create the string which will hold our line
        String line;
        
        // -- after we have done that, we'll need to add the usercode again
        while ((line = brOriginal.readLine()) != null) {
            if (line.contains(USERCODE_START_PATTERN)) {
                System.out.println("Found usercode begin, Merging it now");

                result.get("usercode").append(line).append("\r\n");
                
                while ((line = brOriginal.readLine()) != null) {
                    result.get("usercode").append(line).append("\r\n");
                    
                    if (line.contains(USERCODE_END_PATTERN)) {
                        System.out.println("Found usercode end, Stopped Merging");
                        break;
                    }
                }
            } else if (line.contains(USERIMPORT_START_PATTERN)) {
                result.get("userimport").append(line).append("\r\n");
                
                while ((line = brOriginal.readLine()) != null) {
                    result.get("userimport").append(line).append("\r\n");
                    
                    if (line.contains(USERIMPORT_END_PATTERN)) {
                        break;
                    }
                }
            }
        }
        
        // -- return the resultobject
        return result;
    }
    
    public String mergeUsercode(Reader generated, Reader original) throws IOException {
        // -- create the result object
        StringBuffer result = new StringBuffer();
        
        // -- create buffered readers out of our readers. This way we'll have a
        // -- function called readLine.
        BufferedReader brOriginal = (original == null) ? null : new BufferedReader(original);
        BufferedReader brGenerated = new BufferedReader(generated);

        // -- create the string which will hold our line
        String line;
        String usercode = "";
        String userimport = "";
        
        // -- merge the generated file into the result
        while ((line = brGenerated.readLine()) != null)
            result.append(line).append("\r\n");
        
        if (original != null) {
            Map<String, StringBuffer> res = fetchUsercode(brOriginal);
            
            // -- get the usercode fragments
            usercode = res.get("usercode").toString();
            userimport = res.get("userimport").toString();
        }
        
        // -- create the parameterizedString to substitute the codefragments
        ParameterizedString ps = new ParameterizedString(result.toString());

        // -- add the parameters
        ps.addParameter("usercode", usercode);
        ps.addParameter("userimport", userimport);
        
        // -- return the result
        return ps.parse();
    }
}
